/*
 * HotInt specific configuration.
 * 
 * Copyright (c) 2018, Linz Center of Mechatronics GmbH (LCM) http://www.lcm.at/
 * All rights reserved.
 */
#ifndef HOTINT_H
#define HOTINT_H

#ifdef __cplusplus
extern "C" {
#endif

#include "X2cDataTypes.h"
#include "TcpIpRoutines.h"

/* public prototypes */
void initPortArray(void);

/* Receives status flag and inport values in the negotiated order */
uint8 receiveInportValues(TCPIPSocket* socket, uint32* statusFlag);
/* Sends status flag and outport values in the negotiated order */
uint8 sendOutportValues(TCPIPSocket* socket, uint32* statusFlag);
/* sends update interval time */
uint8 sendUpdateIntervalTime(TCPIPSocket* socket, double time);
/* Receives inport order and sets link table */
uint8 setInportOrder(TCPIPSocket* socket);
/* Receives outport order and sets link table */
uint8 setOutportOrder(TCPIPSocket* socket);
/* Returns update interval */
float64 getUpdateInterval(void);

#ifdef __cplusplus
}
#endif

#endif
